<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class AddRealOrderGroupPackageCardsPartition extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('real_order_cards_partition', function (Blueprint $table) {
            $table->addPartition('real_order_group_package_cards', 'list', [6]);
        });

        Schema::table('real_order_group_package_cards', function (Blueprint $table) {
            $table->unique(['sim', 'order_id', 'refunded_at', 'deleted_at']);
            $table->comment("RD组合包订单关联表");
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('real_order_group_package_cards');
    }
}
