<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class AddVirtualOrderUpgradeCardsPartition extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('virtual_order_cards_partition', function (Blueprint $table) {
            $table->addPartition('virtual_order_upgrade_cards', 'list', [7]);
        });

        Schema::table('virtual_order_upgrade_cards', function (Blueprint $table) {
            $table->unique(['sim', 'order_id', 'deleted_at']);
            $table->index(['type', 'company_id', 'package_id', 'unit_price']);
            $table->index(['service_start_at', 'service_end_at']);
            $table->comment("VD升级订单关联表");
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('virtual_order_upgrade_cards');
    }
}
